/*

    File: Main.h

    Copyright (C) 2000-2007 Christopher Moore (christopher.e.moore@gmail.com)
	  
    This software is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License along
    with this program; if not, write the Free Software Foundation, Inc., 51
    Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/
#if !defined MENU_H
#define MENU_H

#include "menu.h"

//init/shutdown
bool	menuSystemInit(void);
void	menuSystemShutdown(void);

//display all the menus
void	menuSystemDisplay(void);

//execs callback and returns 'true' if we processed something
//returns 'false' if we got nothing
bool	menuSystemGetInput(void);

//menu interactivity
void	menuInit(menu_t *m, float x, float y, float sx, float sy);
menu_t	*menuFind(menu_t *parent, const char *name);
void	menuDestroy(menu_t *menu);
void	menuAddChild(menu_t *parent, menu_t *child);
void	menuUnlinkFromParent(menu_t *child);
menu_t	*menuGetRoot(void);

#endif
