/*

    File: Menu.cpp

    Copyright (C) 2000-2007 Christopher Moore (christopher.e.moore@gmail.com)
	  
    This software is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.
  
    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.
  
    You should have received a copy of the GNU General Public License along
    with this program; if not, write the Free Software Foundation, Inc., 51
    Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

*/
#include <stdlib.h>
#include <string.h>

#include "main.h"
#include "menu.h"

void *menu_t::operator new(size_t size) {
	void *ptr = (malloc)(size);
	if (!ptr) return NULL;
	memset(ptr, 0, size);
	return ptr;
}

void menu_t::operator delete(void *ptr) {
	//handled by menuDestroy in the dtor
}

menu_t::menu_t(float x, float y, float sizeX, float sizeY) {
	(menuInit)(this,x,y,sizeX,sizeY);
}

menu_t::~menu_t(void) {
	//menuDestroy then links the menu up to the dead menu chain
	//which is flushed once per frame
	(menuDestroy)(this);
}

menu_t *menu_t::find(const char *name) {
	return (menuFind)(this,name);
}

void menu_t::addChild(menu_t *child) {
	(menuAddChild)(this,child);
}

void menu_t::unlinkFromParent(void) {
	(menuUnlinkFromParent)(this);
}

menu_t *menu_t::getRoot(void) {
	return (menuGetRoot)();
}
